*********************************************************************
*  Asm09win \}N 6809eXgR[h
*  ̃vO͕xmF-BASIC 3.xœ삵܂
*********************************************************************
          ORG       $1000

ENTRY
*********************************************************************
* CASE01: tOiEQ, =, NE, <>, HI, >, HS, >=, LO, <, LS, <=j
*   FSP[XSUCCEEDED
*********************************************************************
CASE01    CLRA                ;A=0
          CASE01S
          BSR       OUTCR
          BRA       CASE02

CASE01S   MACRO
;CASE:1-1
          $IF       EQ        ;A=0?
            SUCCEED 01,01
          $ELSE
            FAIL    01,01
          $ENDIF
;CASE:1-2
          $IF       =         ;A=0?
            SUCCEED 01,02
          $ELSE
            FAIL    01,02
          $ENDIF
;CASE:1-3
          $IF       NE        ;A<>0?
            FAIL    01,03
          $ELSE
            SUCCEED 01,03
          $ENDIF
;CASE:1-4
          $IF       <>        ;A<>0?
            FAIL    01,04
          $ELSE
            SUCCEED 01,04
          $ENDIF

;CASE:1-5
          $IF       HI        ;A>0?
            FAIL    01,05
          $ELSE
            SUCCEED 01,05
          $ENDIF

;CASE:1-6
          $IF       >         ;A>0?
            FAIL    01,06
          $ELSE
            SUCCEED 01,06
          $ENDIF

;CASE:1-7
          $IF       HS        ;A>=0?
            SUCCEED 01,07
          $ELSE
            FAIL    01,07
          $ENDIF

;CASE:1-8
          $IF       >=        ;A>=0?
            SUCCEED 01,08
          $ELSE
            FAIL    01,08
          $ENDIF

;CASE:1-9
          $IF       LO        ;A<0?
            FAIL    01,09
          $ELSE
            SUCCEED 01,09
          $ENDIF

;CASE:1-A
          $IF       <         ;A<0?
            FAIL    01,10
          $ELSE
            SUCCEED 01,10
          $ENDIF

;CASE:1-B
          $IF       LS        ;A<=0?
            SUCCEED 01,11
          $ELSE
            FAIL    01,11
          $ENDIF

;CASE:1-C
          $IF       <=        ;A<=0?
            SUCCEED 01,12
          $ELSE
            FAIL    01,12
          $ENDIF

;CASE:1-D
          $IF       GE        ;A>=0?
            SUCCEED 01,13
          $ELSE
            FAIL    01,13
          $ENDIF
;CASE:1-E
          $IF       GT        ;A>0?
            FAIL    01,14
          $ELSE
            SUCCEED 01,14
          $ENDIF
;CASE:1-F
          $IF       LE        ;A<=0?
            SUCCEED 01,15
          $ELSE
            FAIL    01,15
          $ENDIF
;CASE:1-10
          $IF       LT        ;A<0?
            FAIL    01,16
          $ELSE
            SUCCEED 01,16
          $ENDIF

          ENDM

*********************************************************************
* CASE02: tOiGE, GT, LE, LTjtr
*   FSP[XSUCCEEDED
*********************************************************************
CASE02    LDA       #1        ;A=1
          CMPA      #-1
          CASE02S
          BSR       OUTCR
          BRA       CASE03

CASE02S   MACRO
;CASE:2-1
          $IF       GE        ;A>=-1?
            SUCCEED 02,01
          $ELSE
            FAIL    02,01
          $ENDIF
;CASE:2-2
          $IF       GT        ;A>-1?
            SUCCEED 02,02
          $ELSE
            FAIL    02,02
          $ENDIF
;CASE:2-3
          $IF       LE        ;A<=-1?
            FAIL    02,03
          $ELSE
            SUCCEED 02,03
          $ENDIF
;CASE:2-4
          $IF       LT        ;A<-1?
            FAIL    02,04
          $ELSE
            SUCCEED 02,04
          $ENDIF

          ENDM

*********************************************************************
* CASE03: tOiPL, +, MI, -j
*   FSP[XSUCCEEDED
*********************************************************************
CASE03    LDA       #-1       ;A=-1
          CASE03S
          BSR       OUTCR
          BRA       CASE04

CASE03S   MACRO
;CASE:3-1
          $IF       +         ;A is plus?
            FAIL    03,01
          $ELSE
            SUCCEED 03,01
          $ENDIF
;CASE:3-2
          $IF       PL        ;A is plus?
            FAIL    03,02
          $ELSE
            SUCCEED 03,02
          $ENDIF
;CASE:3-3
          $IF       -         ;A is minus?
            SUCCEED 03,03
          $ELSE
            FAIL    03,03
          $ENDIF

;CASE:3-4
          $IF       MI        ;A is minus?
            SUCCEED 03,04
          $ELSE
            FAIL    03,04
          $ENDIF

          ENDM

*********************************************************************
* CASE04: tOiCC, CSj
*   FSP[XSUCCEEDED
*********************************************************************
CASE04    ORCC      #1        ;Carry set
          CASE04S
          BSR       OUTCR
          BRA       CASE05

CASE04S   MACRO
;CASE:4-1
          $IF       CC        ;Carry clear?
            FAIL    04,01
          $ELSE
            SUCCEED 04,01
          $ENDIF
;CASE:4-2
          $IF       CS        ;Carry set?
            SUCCEED 04,02
          $ELSE
            FAIL    04,02
          $ENDIF

          ENDM

*********************************************************************
* CASE05: tOiVC, VSj
*   FSP[XSUCCEEDED
*********************************************************************
CASE05    LDD       #$7FFF    ;D = 32767+1  ->  -1
          ADDD      #1
          CASE05S
          BSR       OUTCR
          BRA       CASE06

CASE05S   MACRO
;CASE:5-1
          $IF       VC        ;D is not overflow?
            FAIL    05,01
          $ELSE
            SUCCEED 05,01
          $ENDIF
;CASE:5-2
          $IF       VS        ;D is overflow?
            SUCCEED 05,02
          $ELSE
            FAIL    05,02
          $ENDIF

          ENDM

*********************************************************************
* CASE06: iD=0, D=X Zq: = <> > >= < <= j
*   FSP[XSUCCEEDED
*********************************************************************
CASE06    LDD       #1000     ;D=1000, n=1000, X=1001
          LDX       #1001
          CASE06S   1000
          BSR       OUTCR
          BRA       CASE07

CASE06S   MACRO     n
;CASE:6-1
          $IF       D=&n      ;D=n?
            SUCCEED 06,01
          $ELSE
            FAIL    06,01
          $ENDIF
;CASE:6-2
          $IF       D<>&n     ;D<>n?
            FAIL    06,02
          $ELSE
            SUCCEED 06,02
          $ENDIF
;CASE:6-3
          $IF       D>&n      ;D>n?
            FAIL    06,03
          $ELSE
            SUCCEED 06,03
          $ENDIF
;CASE:6-4
          $IF       D>=&n     ;D>=n?
            SUCCEED 06,04
          $ELSE
            FAIL    06,04
          $ENDIF
;CASE:6-5
          $IF       D<&n      ;D<n?
            FAIL    06,05
          $ELSE
            SUCCEED 06,05
          $ENDIF
;CASE:6-6
          $IF       D<=&n     ;D<=n?
            SUCCEED 06,06
          $ELSE
            FAIL    06,06
          $ENDIF

;CASE:6-7
          $IF       D=X       ;D=X?
            FAIL    06,07
          $ELSE
            SUCCEED 06,07
          $ENDIF
;CASE:6-8
          $IF       D<>X      ;D<>X?
            SUCCEED 06,08
          $ELSE
            FAIL    06,08
          $ENDIF
;CASE:6-9
          $IF       D>X       ;D>X?
            FAIL    06,09
          $ELSE
            SUCCEED 06,09
          $ENDIF
;CASE:6-A
          $IF       D>=X      ;D>=X?
            FAIL    06,10
          $ELSE
            SUCCEED 06,10
          $ENDIF
;CASE:6-B
          $IF       D<X       ;D<X?
            SUCCEED 06,11
          $ELSE
            FAIL    06,11
          $ENDIF
;CASE:6-C
          $IF       D<=X      ;D<=X?
            SUCCEED 06,12
          $ELSE
            FAIL    06,12
          $ENDIF

          ENDM

*********************************************************************
* CASE07: iA=(addr)j
*   FSP[XSUCCEEDED
*********************************************************************
CASE07    LDA       #100      ;A=100, (addr)=100, (addr+2)=101, (addr+4)=99
          STA       addr
          LDB       #101
          STB       addr+2
          LDB       #99
          STB       addr+4
          LDY       #addr     ;Y=addr
          LDB       #4        ;B=4
          CASE07S
          BSR       OUTCR
          BRA       CASE08

CASE07S   MACRO
;CASE:7-1
          $IF       A=(addr)  ;A=(addr)?
            SUCCEED 07,01
          $ELSE
            FAIL    07,01
          $ENDIF
;CASE:7-2
          $IF       A<>(Y)    ;A<>(addr)?
            FAIL    07,02
          $ELSE
            SUCCEED 07,02
          $ENDIF
;CASE:7-3
          $IF       A>(Y+2)   ;A>(addr+2)?
            FAIL    07,03
          $ELSE
            SUCCEED 07,03
          $ENDIF
;CASE:7-4
          $IF       A>=(Y+B)  ;A>=(addr+4)?
            SUCCEED 07,04
          $ELSE
            FAIL    07,04
          $ENDIF
;CASE:7-5
          $IF       A<(Y+)    ;A<(addr+)?
            FAIL    07,05
          $ELSE
            SUCCEED 07,05
          $ENDIF
;CASE:7-6
          $IF       A<=(-Y)   ;A<=(-addr)?
            SUCCEED 07,06
          $ELSE
            FAIL    07,06
          $ENDIF

          ENDM

*********************************************************************
* CASE08: iD=[addr]j
*   FSP[XSUCCEEDED
*********************************************************************
CASE08    LDA       #100      ;A=100, [addr]=(addr+2)=100, [addr+4]=(addr+6)=101
          STA       addr+2
          LDB       #101
          STB       addr+6
          LDX       #addr+2
          STX       addr
          LDX       #addr+6
          STX       addr+4
          LDY       #addr     ;Y=addr
          LDB       #4        ;B=4
          CASE08S
          BSR       OUTCR
          BRA       CASE09

CASE08S   MACRO
;CASE:8-1
          $IF       A=[addr]  ;A=[addr]?
            SUCCEED 08,01
          $ELSE
            FAIL    08,01
          $ENDIF
;CASE:8-2
          $IF       A<>[Y]    ;A<>[addr]?
            FAIL    08,02
          $ELSE
            SUCCEED 08,02
          $ENDIF
;CASE:8-3
          $IF       A>[4+Y]  ;A>[addr+4]?
            FAIL    08,03
          $ELSE
            SUCCEED 08,03
          $ENDIF
;CASE:8-4
          $IF       A>=[B,Y]  ;A>=[addr+4]?
            FAIL    08,04
          $ELSE
            SUCCEED 08,04
          $ENDIF
;CASE:8-5
          $IF       A<[Y++]    ;A<[addr++]?
            FAIL    08,05
          $ELSE
            SUCCEED 08,05
          $ENDIF
;CASE:8-6
          $IF       A<=[--Y]   ;A<=[--addr]?
            SUCCEED 08,06
          $ELSE
            FAIL    08,06
          $ENDIF

          ENDM

*********************************************************************
* CASE09: $ELIF
*   FSUCCEEDED
*********************************************************************
CASE09    LDD       #100      ;D=100

          $IF       D=0       ;D=0?
            FAIL    09,01
          $ELIF     D=10      ;D=10?
            FAIL    09,01
          $ELIF     D=100     ;D=100
            SUCCEED 09,01
          $ELSE               ;ELSE?
            FAIL    09,01
          $ENDIF

          BSR       OUTCR

*********************************************************************
* CASE0A: $WHILE
*   F\v
*********************************************************************
CASE0A    LDD       #$0A01
          LEAX      CRMSG,PCR
          BSR       OUTMSG
          LEAX      MSG08,PCR
          BSR       OUTLN
          LDA       #$20

          $WHILE    A<$2A
            BSR     OUT2H
            BSR     OUTSPC
            INCA
          $WEND

          BSR       OUTCR
          BSR       OUTCR
          BRA       CASE0B

MSG08     FCC       /20 21 22 23 24 25 26 27 28 29 IF SAME BELOW,SUCCEEDED/,$0D,$0A,0

*********************************************************************
* CASE0B: $REPEAT
*   F\v
*********************************************************************
CASE0B    LDD       #$0B01
          LEAX      CRMSG,PCR
          BSR       OUTMSG
          LEAX      MSG0B,PCR
          BSR       OUTLN
          LDD       #$1234

          $REPEAT
            BSR     OUT4H
            BSR     OUTSPC
            SUBD    #1
          $UNTIL    D<$1230

          BSR       OUTCR
          BSR       OUTCR
          BRA       CASE0C

MSG0B     FCC       /1234 1233 1232 1231 1230 IF SAME BELOW,SUCCEEDED/,$0D,$0A,0

*********************************************************************
* CASE0C: $BREAK, $CONTINUE (WHILE LOOP)
*   F\v
*********************************************************************
CASE0C    LDD       $0C01
          LEAX      CRMSG,PCR
          BSR       OUTMSG
          LEAX      MSG0C,PCR
          BSR       OUTLN
          LDA       #0

          $WHILE    A<$FF
            INCA

            $IF     A<$20
              $CONTINUE
            $ENDIF

            $IF     A>=$2A
              $BREAK
            $ENDIF

            BSR     OUT2H
            BSR     OUTSPC
          $WEND

          BSR       OUTCR
          BSR       OUTCR
          BRA       CASE0D

MSG0C     FCC       /20 21 22 23 24 25 26 27 28 29 IF SAME BELOW,SUCCEEDED/,$0D,$0A,0

*********************************************************************
* CASE0D: $BREAK, $CONTINUE (REPEAT LOOP)
*   F\v
*********************************************************************
CASE0D    LDD       #$0B01
          LEAX      CRMSG,PCR
          BSR       OUTMSG
          LEAX      MSG0B,PCR
          BSR       OUTLN
          LDD       #$2000

          $REPEAT
            SUBD    #1

            $IF     D>$1234
              $CONTINUE
            $ENDIF

            $IF     D<$1230
              $BREAK
            $ENDIF

            BSR     OUT4H
            BSR     OUTSPC
          $UNTIL    D<$1230

          BSR       OUTCR
          BSR       OUTCR
          BRA       CASE0E

MSG0D     FCC       /1234 1233 1232 1231 1230 IF SAME BELOW,SUCCEEDED/,$0D,$0A,0

*********************************************************************
* CASE0E: $BREAK, $CONTINUE (NESTED LOOP)
*   F\vi5񔽕j
*********************************************************************
CASE0E    LDD       #$0C01
          LEAX      CRMSG,PCR
          BSR       OUTMSG
          LEAX      MSG0E,PCR
          BSR       OUTLN
          LDX       #0

          $WHILE    X<$00FF
            LEAX    1,X

            $IF     X>5
              $BREAK
            $ENDIF

            LDD     #0

            $REPEAT
              ADDD  #1

              $IF   D>5
                $CONTINUE
              $ENDIF

              BSR   OUT4H
              BSR   OUTSPC

            $UNTIL  D>=10

            BSR     OUTCR

          $WEND

          BSR       OUTCR
          BSR       OUTCR
          BRA       EXIT

MSG0E     FCC       /0001 0002 0003 0004 0005 IF SAME BELOW,SUCCEEDED/,$0D,$0A,0

*********************************************************************
* 1so
*********************************************************************
SUCCEED   MACRO     CaseNo,SubNo
          PSHS      CC,D,X
          LDD       #&CaseNo*256+&SubNo
          LEAX      MSGSC,PCR
          BSR       OUTMSG
          PULS      CC,D,X
          ENDM

FAIL      MACRO     CaseNo,SubNo
          PSHS      CC,D,X
          LDD       #&CaseNo*256+&SubNo
          LEAX      MSGFL,PCR
          BSR       OUTMSG
          PULS      CC,D,X
          ENDM

OUTMSG    PSHS      X
          LEAX      MSGCASE,PCR
          BSR       OUTLN
          BSR       OUT2H
          LDA       #'-
          BSR       OUTC
          TFR       B,A
          BSR       OUT2H
          PULS      X
          BSR       OUTLN
          RTS

MSGCASE   FCC       /CASE:/,0
MSGSC     FCC       / SUCCEEDED./,$0D,$0A,0
MSGFL     FCC       / FAILED./,$0D,$0A,0

*********************************************************************
* 1so in:X
*********************************************************************
OUTLN     PSHS      D,X
          BSR       HALT
          LDD       #$0300    ;$03:console put
          STA       $FC82
          LDU       #$FC84
DSPL_1    INCB
          LDA       ,X+
          STA       ,U+
          BNE       DSPL_1
          CLR       $FC81     ;no continue
          STB       $FC83     ;length of string
          BSR       SUBRST
          PULS      D,X,PC

HALT      TST       $FD05
          BMI       HALT
          LDA       #$80
          STA       $FD05
HALT_2    TST       $FD05
          BPL       HALT_2
          RTS

SUBRST    CLR     $FD05
          RTS

*********************************************************************
* 16i4o in:D
*********************************************************************
OUT4H     PSHS      D
          BSR       OUT2H
          TFR       B,A
          BSR       OUT2H
          PULS      D,PC

*********************************************************************
* 16i2o in:A
*********************************************************************
OUT2H     PSHS      A
          LSRA
          LSRA
          LSRA
          LSRA
          BSR       OUT1H
          LDA       ,S
          BSR       OUT1H
          PULS      A,PC
OUT1H     ANDA      #$0F
          ADDA      #'0
          CMPA      #$3A
          BLO       OUT1H_1
          ADDA      #7
OUT1H_1   BSR       OUTC
          RTS

OUTC      PSHS      A,X
          STA       ASCMSG,PCR
          LEAX      ASCMSG,PCR
          BSR       OUTLN
          PULS      A,X,PC

OUTCR     PSHS      X
          LEAX      CRMSG,PCR
          BSR       OUTLN
          PULS      X,PC

OUTSPC    PSHS      A
          LDA       #' '
          BSR       OUTC
          PULS      A,PC

*********************************************************************
* bZ[W[N
*********************************************************************
ASCMSG    FCB       0,0
CRMSG     FCB       $0D,$0A,0

addr      FDB       0,0,0,0

*********************************************************************
* END OF PROGRAM
*********************************************************************
EXIT      RTS
          END       ENTRY
