;--------------------------------------------------------------------
;  Asm09win \}N Z80eXgR[h
;  ̃vOCP/M80œ삵܂
;--------------------------------------------------------------------
          ORG       100H

ENTRY:
;--------------------------------------------------------------------
; CASE01: tOiZ, =, 0, NZ, <>j
;   FSP[XSUCCEEDED
;--------------------------------------------------------------------
CASE01:   LD        A,0       ;A=0
          CP        0
          CASE01S
          CALL      OUTCR

CASE01S:  MACRO
;CASE:1-1
          $IF       Z         ;A=0?
            SUCCEED 01,01
          $ELSE
            FAIL    01,01
          $ENDIF
;CASE:1-2
          $IF       =         ;A=0?
            SUCCEED 01,02
          $ELSE
            FAIL    01,02
          $ENDIF
;CASE:1-3
          $IF       0         ;A=0?
            SUCCEED 01,03
          $ELSE
            FAIL    01,03
          $ENDIF
;CASE:1-4
          $IF       NZ        ;A<>0?
            FAIL    01,04
          $ELSE
            SUCCEED 01,04
          $ENDIF
;CASE:1-5
          $IF       <>        ;A<>0?
            FAIL    01,05
          $ELSE
            SUCCEED 01,05
          $ENDIF
          ENDM

;--------------------------------------------------------------------
; CASE02: tOi>=, NC, <, Cj
;   FSP[XSUCCEEDED
;--------------------------------------------------------------------
CASE02:   LD        A,1       ;A=1
          CP        1
          CASE02S
          CALL      OUTCR

CASE02S:  MACRO
;CASE:2-1
          $IF       >=        ;A>=1?
            SUCCEED 02,01
          $ELSE
            FAIL    02,01
          $ENDIF
;CASE:2-2
          $IF       NC        ;A>=1?
            SUCCEED 02,02
          $ELSE
            FAIL    02,02
          $ENDIF
;CASE:2-3
          $IF       <         ;A<1?
            FAIL    02,03
          $ELSE
            SUCCEED 02,03
          $ENDIF
;CASE:2-4
          $IF       C         ;A<1?
            FAIL    02,04
          $ELSE
            SUCCEED 02,04
          $ENDIF
          ENDM

;--------------------------------------------------------------------
; CASE03: tOiP, +, M, -j
;   FSP[XSUCCEEDED
;--------------------------------------------------------------------
CASE03:   LD        A,0       ;A=0
          CP        0
          CASE03S
          CALL      OUTCR

CASE03S:  MACRO
;CASE:3-1
          $IF       P         ;A is plus?
            SUCCEED 03,01
          $ELSE
            FAIL    03,01
          $ENDIF
;CASE:3-2
          $IF       +         ;A is plus?
            SUCCEED 03,02
          $ELSE
            FAIL    03,02
          $ENDIF
;CASE:3-3
          $IF       M         ;A is minus?
            FAIL    03,03
          $ELSE
            SUCCEED 03,03
          $ENDIF
;CASE:3-4
          $IF       -         ;A is minus?
            FAIL    03,04
          $ELSE
            SUCCEED 03,04
          $ENDIF
          ENDM

;--------------------------------------------------------------------
; CASE04: tOiPO, PEj
;   FSP[XSUCCEEDED
;--------------------------------------------------------------------
CASE04:   LD        A,255     ;A=255+1
          ADD       A,1
          CASE04S
          CALL      OUTCR

CASE04S:  MACRO
;CASE:4-1
          $IF       PO        ;A is overflow?
            SUCCEED 04,01
          $ELSE
            FAIL    04,01
          $ENDIF
;CASE:4-2
          $IF       PE        ;A is not overflow?
            FAIL    04,02
          $ELSE
            SUCCEED 04,02
          $ENDIF
          ENDM

;--------------------------------------------------------------------
; CASE05: iA=0, A=B, A=(HL) Zq: = <> > >= < <= j
;   FSP[XSUCCEEDED
;--------------------------------------------------------------------
CASE05:   LD        A,100     ;A=100, n=100, B=101, (HL)=99
          LD        B,101
          LD        HL,HLWK
          LD        (HL),99
          CASE05S   100
          CALL      OUTCR

CASE05S:  MACRO     n
;CASE:5-1
          $IF       A=&n      ;A=n?
            SUCCEED 05,01
          $ELSE
            FAIL    05,01
          $ENDIF
;CASE:5-2
          $IF       A<>&n     ;A<>n?
            FAIL    05,02
          $ELSE
            SUCCEED 05,02
          $ENDIF
;CASE:5-3
          $IF       A>&n      ;A>n?
            FAIL    05,03
          $ELSE
            SUCCEED 05,03
          $ENDIF
;CASE:5-4
          $IF       A>=&n     ;A>=n?
            SUCCEED 05,04
          $ELSE
            FAIL    05,04
          $ENDIF
;CASE:5-5
          $IF       A<&n      ;A<n?
            FAIL    05,05
          $ELSE
            SUCCEED 05,05
          $ENDIF
;CASE:5-6
          $IF       A<=&n     ;A<=n?
            SUCCEED 05,06
          $ELSE
            FAIL    05,06
          $ENDIF


;CASE:5-7
          $IF       A=B       ;A=B?
            FAIL    05,07
          $ELSE
            SUCCEED 05,07
          $ENDIF
;CASE:5-8
          $IF       A<>B      ;A<>B?
            SUCCEED 05,08
          $ELSE
            FAIL    05,08
          $ENDIF
;CASE:5-9
          $IF       A>B       ;A>B?
            FAIL    05,09
          $ELSE
            SUCCEED 05,09
          $ENDIF
;CASE:5-A
          $IF       A>=B      ;A>=B?
            FAIL    05,10
          $ELSE
            SUCCEED 05,10
          $ENDIF
;CASE:5-B
          $IF       A<B       ;A<B?
            SUCCEED 05,11
          $ELSE
            FAIL    05,11
          $ENDIF
;CASE:5-C
          $IF       A<=B      ;A<=B?
            SUCCEED 05,12
          $ELSE
            FAIL    05,12
          $ENDIF


;CASE:5-D
          $IF       A=(HL)    ;A=(HL)?
            FAIL    05,13
          $ELSE
            SUCCEED 05,13
          $ENDIF
;CASE:5-E
          $IF       A<>(HL)   ;A<>(HL)?
            SUCCEED 05,14
          $ELSE
            FAIL    05,14
          $ENDIF
;CASE:5-F
          $IF       A>(HL)    ;A>(HL)?
            SUCCEED 05,15
          $ELSE
            FAIL    05,15
          $ENDIF
;CASE:5-10
          $IF       A>=(HL)   ;A>=(HL)?
            SUCCEED 05,16
          $ELSE
            FAIL    05,16
          $ENDIF
;CASE:5-11
          $IF       A<(HL)    ;A<(HL)?
            FAIL    05,17
          $ELSE
            SUCCEED 05,17
          $ENDIF
;CASE:5-12
          $IF       A<=(HL)   ;A<=(HL)?
            FAIL    05,18
          $ELSE
            SUCCEED 05,18
          $ENDIF
          ENDM

;--------------------------------------------------------------------
; CASE06: iBC=0, BC=DE, BC=(HL) Zq: = <> > >= < <= j
;   FSP[XSUCCEEDED
;--------------------------------------------------------------------
CASE06:   LD        BC,100    ;BC=100, DE=101, (HL)=99 -> LOW
          LD        DE,101
          LD        HL,99
          LD        (HLWK),HL
          LD        HL,HLWK
          CASE06S   100,0

          LD        BC,1234H  ;BC=1234H, DE=1333H, (HL)=1135H -> HIGH
          LD        DE,1333H
          LD        HL,1135H
          LD        (HLWK),HL
          LD        HL,HLWK
          CASE06S   1234H,18
          CALL      OUTCR

CASE06S:  MACRO     nn,add
;CASE:6-1, 6-13
          $IF       BC=&nn    ;BC=nn?
            SUCCEED 06,01+&add
          $ELSE
            FAIL    06,01+&add
          $ENDIF
;CASE:6-2, 6-14
          $IF       BC<>&nn   ;BC<>nn?
            FAIL    06,02+&add
          $ELSE
            SUCCEED 06,02+&add
          $ENDIF
;CASE:6-3, 6-15
          $IF       BC>=&nn   ;BC>=nn?
            SUCCEED 06,03+&add
          $ELSE
            FAIL    06,03+&add
          $ENDIF
;CASE:6-4, 6-16
          $IF       BC<&nn    ;BC<nn?
            FAIL    06,04+&add
          $ELSE
            SUCCEED 06,04+&add
          $ENDIF
;CASE:6-5, 6-17
          $IF       BC<=&nn   ;BC<=nn?
            SUCCEED 06,05+&add
          $ELSE
            FAIL    06,05+&add
          $ENDIF
;CASE:6-6, 6-18
          $IF       BC>&nn    ;BC>nn?
            FAIL    06,06+&add
          $ELSE
            SUCCEED 06,06+&add
          $ENDIF

;CASE:6-7, 6-19
          $IF       BC=DE     ;BC=DE?
            FAIL    06,07+&add
          $ELSE
            SUCCEED 06,07+&add
          $ENDIF
;CASE:6-8, 6-1A
          $IF       BC<>DE    ;BC<>DE?
            SUCCEED 06,08+&add
          $ELSE
            FAIL    06,08+&add
          $ENDIF
;CASE:6-9, 6-1B
          $IF       BC>=DE    ;BC>=DE?
            FAIL    06,09+&add
          $ELSE
            SUCCEED 06,09+&add
          $ENDIF
;CASE:6-A, 6-1C
          $IF       BC<DE     ;BC<DE?
            SUCCEED 06,10+&add
          $ELSE
            FAIL    06,10+&add
          $ENDIF
;CASE:6-B, 6-1D
          $IF       BC<=DE    ;BC<=BC?
            SUCCEED 06,11+&add
          $ELSE
            FAIL    06,11+&add
          $ENDIF
;CASE:6-C, 6-1E
          $IF       BC>DE     ;BC>DE?
            FAIL    06,12+&add
          $ELSE
            SUCCEED 06,12+&add
          $ENDIF

;CASE:6-D, 6-1F
          $IF       BC=(HL)   ;BC=(HL)?
            FAIL    06,13+&add
          $ELSE
            SUCCEED 06,13+&add
          $ENDIF
;CASE:6-E, 6-20
          $IF       BC<>(HL)  ;BC<>(HL)?
            SUCCEED 06,14+&add
          $ELSE
            FAIL    06,14+&add
          $ENDIF
;CASE:6-F, 6-21
          $IF       BC>=(HL)  ;BC>=(HL)?
            SUCCEED 06,15+&add
          $ELSE
            FAIL    06,15+&add
          $ENDIF
;CASE:6-10, 6-22
          $IF       BC<(HL)   ;BC<(HL)?
            FAIL    06,16+&add
          $ELSE
            SUCCEED 06,16+&add
          $ENDIF
;CASE:6-11, 6-23
          $IF       BC<=(HL)  ;BC<=(HL)?
            FAIL    06,17+&add
          $ELSE
            SUCCEED 06,17+&add
          $ENDIF
;CASE:6-12, 6-24
          $IF       BC>(HL)   ;BC>(HL)?
            SUCCEED 06,18+&add
          $ELSE
            FAIL    06,18+&add
          $ENDIF
          ENDM

;--------------------------------------------------------------------
; CASE07: $ELIF
;   FSUCCEEDED
;--------------------------------------------------------------------
CASE07:   LD        BC,100    ;BC=100

          $IF       BC=0      ;BC=0?
            FAIL    07,01
          $ELIF     BC=10     ;BC=10?
            FAIL    07,01
          $ELIF     BC=100    ;BC=100
            SUCCEED 07,01
          $ELSE               ;ELSE?
            FAIL    07,01
          $ENDIF

          CALL      OUTCR

;--------------------------------------------------------------------
; CASE08: $WHILE
;   F\v
;--------------------------------------------------------------------
CASE08:   LD        BC,0801H
          LD        DE,CRMSG
          CALL      OUTMSG
          LD        DE,MSG08
          CALL      OUTLN
          LD        D,20H

          $WHILE    D<2AH
            LD      B,D
            CALL    OUT2H
            CALL    OUTSPC
            INC     D
          $WEND

          CALL      OUTCR
          CALL      OUTCR
          GOTO      CASE09

MSG08:    DB        "20 21 22 23 24 25 26 27 28 29 IF SAME BELOW,SUCCEEDED",0DH,0AH,'$'

;--------------------------------------------------------------------
; CASE09: $REPEAT
;   F\v
;--------------------------------------------------------------------
CASE09:   LD        BC,0901H
          LD        DE,CRMSG
          CALL      OUTMSG
          LD        DE,MSG09
          CALL      OUTLN
          LD        HL,1234H

          $REPEAT
            LD      B,H
            LD      C,L
            CALL    OUT4H
            CALL    OUTSPC
            DEC     HL
          $UNTIL    HL<1230H

          CALL      OUTCR
          CALL      OUTCR
          GOTO      CASE0A

MSG09:    DB        "1234 1233 1232 1231 1230 IF SAME BELOW,SUCCEEDED",0DH,0AH,'$'

;--------------------------------------------------------------------
; CASE0A: $BREAK, $CONTINUE (WHILE LOOP)
;   F\v
;--------------------------------------------------------------------
CASE0A:   LD        BC,0A01H
          LD        DE,CRMSG
          CALL      OUTMSG
          LD        DE,MSG0A
          CALL      OUTLN
          LD        D,00H

          $WHILE    D<0FFH
            INC     D

            $IF     D<20H
              $CONTINUE
            $ENDIF

            $IF     D>=2AH
              $BREAK
            $ENDIF

            LD      B,D
            CALL    OUT2H
            CALL    OUTSPC
          $WEND

          CALL      OUTCR
          CALL      OUTCR
          GOTO      CASE0B

MSG0A:    DB        "20 21 22 23 24 25 26 27 28 29 IF SAME BELOW,SUCCEEDED",0DH,0AH,'$'

;--------------------------------------------------------------------
; CASE0B: $BREAK, $CONTINUE (REPEAT LOOP)
;   F\v
;--------------------------------------------------------------------
CASE0B:   LD        BC,0B01H
          LD        DE,CRMSG
          CALL      OUTMSG
          LD        DE,MSG0B
          CALL      OUTLN
          LD        HL,2000H

          $REPEAT
            DEC     HL

            $IF     HL>1234H
              $CONTINUE
            $ENDIF

            $IF     HL<1230H
              $BREAK
            $ENDIF

            LD      B,H
            LD      C,L
            CALL    OUT4H
            CALL    OUTSPC
          $UNTIL    HL<1230H

          CALL      OUTCR
          CALL      OUTCR
          GOTO      CASE0C

MSG0B:    DB        "1234 1233 1232 1231 1230 IF SAME BELOW,SUCCEEDED",0DH,0AH,'$'

;--------------------------------------------------------------------
; CASE0C: $BREAK, $CONTINUE (NESTED LOOP)
;   F\vi5񔽕j
;--------------------------------------------------------------------
CASE0C:   LD        BC,0C01H
          LD        DE,CRMSG
          CALL      OUTMSG
          LD        DE,MSG0C
          CALL      OUTLN
          LD        D,0

          $WHILE    D<0FFH
            INC     D

            $IF     D>5
              $BREAK
            $ENDIF

            LD      HL,0

            $REPEAT
              INC   HL

              $IF   HL>5
                $CONTINUE
              $ENDIF

              LD    B,H
              LD    C,L
              CALL  OUT4H
              CALL  OUTSPC

            $UNTIL  HL>=10

            CALL    OUTCR

          $WEND

          CALL      OUTCR
          CALL      OUTCR
          GOTO      EXIT

MSG0C:    DB        "0001 0002 0003 0004 0005 IF SAME BELOW,SUCCEEDED",0DH,0AH,'$'

;--------------------------------------------------------------------
; x`
;--------------------------------------------------------------------
BDOS      EQU       5         ;BDOS ENTRY POINT
PMSG      EQU       9         ;PRINT FUNCTION

;--------------------------------------------------------------------
; 1so
;--------------------------------------------------------------------
SUCCEED:  MACRO     CaseNo, SubNo
          PUSH DE ! PUSH BC ! PUSH AF
          LD        BC,&CaseNo*256+&SubNo
          LD        DE,MSGSC
          CALL      OUTMSG
          POP  AF ! POP  BC ! POP  DE
          ENDM

FAIL:     MACRO     CaseNo,SubNo
          PUSH DE ! PUSH BC ! PUSH AF
          LD        BC,&CaseNo*256+&SubNo
          LD        DE,MSGFL
          CALL      OUTMSG
          POP  AF ! POP  BC ! POP  DE
          ENDM

OUTMSG:   PUSH      DE
          LD        DE,MSGCASE
          CALL      OUTLN
          CALL      OUT2H
          LD        A,'-'
          CALL      OUTC
          LD        B,C
          CALL      OUT2H
          POP       DE
          CALL      OUTLN
          RET

MSGCASE:  DB        "CASE:",'$'
MSGSC     DB        " SUCCEEDED.",0DH,0AH,'$'
MSGFL     DB        " FAILED.",0DH,0AH,'$'

;--------------------------------------------------------------------
; 1so in:DE
;--------------------------------------------------------------------
OUTLN:    PUSH BC ! PUSH HL
          LD        C,PMSG
          CALL      BDOS
          POP  HL ! POP  BC
          RET

;--------------------------------------------------------------------
; 16i4o in:BC
;--------------------------------------------------------------------
OUT4H:    PUSH      BC
          CALL      OUT2H
          LD        B,C
          CALL      OUT2H
          POP       BC
          RET

;--------------------------------------------------------------------
; 16i2o in:B
;--------------------------------------------------------------------
OUT2H:    PUSH      AF
          LD        A,B
          SRL A ! SRL A ! SRL A ! SRL A
          CALL      OUT1H
          LD        A,B
          CALL      OUT1H
          POP       AF
          RET
OUT1H:    AND       0FH
          ADD       A,'0'
          CP        3AH
          GOTO      C,OUT1H_1
          ADD       A,7
OUT1H_1:  CALL      OUTC
          RET

OUTC:     LD        (ASCMSG),A
          PUSH      DE
          LD        DE,ASCMSG
          CALL      OUTLN
          POP       DE
          RET

OUTCR:    PUSH      DE
          LD        DE,CRMSG
          CALL      OUTLN
          POP       DE
          RET

OUTSPC:   LD        A,' '
          CALL      OUTC
          RET

;--------------------------------------------------------------------
; bZ[W[N
;--------------------------------------------------------------------
ASCMSG:   DB        0,'$'
CRMSG:    DB        0DH,0AH,'$'

HLWK:     DW        0

;--------------------------------------------------------------------
; END OF PROGRAM
;--------------------------------------------------------------------
EXIT:     RET
          END       ENTRY
